//+------------------------------------------------------------------+
//|                                                     TFX v1_2.mq4 |
//|                                           Copyright  2008 Wolfe |
//|                                                www.forex-tsd.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008 Wolfe"
#property link      "www.forex-tsd.com"

extern double        Start_Lot_Size=0.1;//starting lot size for cycle
extern double        Lot_Size_Increment=0.1;//Additional orders will increase by this amount
extern bool          Double_Lotsize=false;//set to true if you want to just double every lotsize, Lot_Size_Increment ignored if true
extern int           Max_Trades=50;//maximum number of trades allowed
extern bool          Close_All_Max=false;//select true if you want ALL orders to close if Max_Trades is hit 
extern int           Next_Trade=10;//next trade pip increment, (will trade this many pips above OR below last order)
extern bool          Close_By_Percent=false;//If true it will close by percent, if false it will close by Profit or Loss in $$
extern double        TP_Percent=5;//will take profit if profit is greater than percent of account balance (close all orders)
extern double        SL_Percent=10;//will stop loss if profit is less than percent of account balance (close all orders)
extern double        Close_By_Profit=10;//close if >= to this $ amount
extern double        Close_By_Loss=-50;//close if <= to this $ amount (make sure a negative number is entered)
extern int           MA_Period=7;//moving average period for calculation
extern int           Timeframe=5;//timeframe used for MA calculation, 1=1m, 2=5m, 3=15m, 4=30m, 5=1h, 6=4h, 7=1d
extern bool          Use_Manual_Entry=false;//if true you must enter Manuel_Long & Manuel_Short price you want trade to execute, if false MA will start trade cycle
extern double        Manual_Long=0;//Price at which to start cycle long
extern double        Manual_Short=0;//Price at which to start cycle short
extern int           Slippage=5;
extern int           Magic_Number=9009;




double Lot_Size;
int MA_Timeframe;
double MA_Current;
double MA_Previous;
static int Ticket;
static double Open_Last;
static double Last_Lotsize;
double Take_Profit;
double Stop_Loss;
bool Trade_Allowed=true;

#include <TFX_Include_v1_2.mqh>


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
  
if (Timeframe==1){MA_Timeframe=1;}
if (Timeframe==2){MA_Timeframe=5;}
if (Timeframe==3){MA_Timeframe=15;}
if (Timeframe==4){MA_Timeframe=30;}
if (Timeframe==5){MA_Timeframe=60;}
if (Timeframe==6){MA_Timeframe=240;}
if (Timeframe==7){MA_Timeframe=1440;}

if (Use_Manual_Entry==true)
{
if (Manual_Long==0){Trade_Allowed=false;Alert("TRADE DISABLED *** SET MANUEL_LONG");}
if (Manual_Short==0){Trade_Allowed=false;Alert("TRADE DISABLED *** SET MANUEL_SHORT");}
}

Take_Profit=TP_Percent*0.01;
Stop_Loss=SL_Percent*0.01;

if (Use_Manual_Entry==true)
{
 Comment("             ");
 Comment("SHORT ENTRY PRICE = ",Manual_Short," LONG ENTRY PRICE = ",Manual_Long);
}
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  
//////////////////////////////////////////Take Profit or Stop Loss by Percent of Account Balance or by Profit/////////////////////////////////
//                                                     *** If Use_Manuel_Entry = false ***
if (Use_Manual_Entry==false)
{
if (Close_All_Max==true)
 {
  if (OTBM(Magic_Number)==Max_Trades)
   {
    CBM(Magic_Number);
    Print("                                                                               ***MAX TRADE HIT CLOSE ALL PERFORMED***");
   }
 }

if (Close_By_Percent==true)
{ 
if (AccountProfit() >= AccountBalance()*(Take_Profit))
 {
  CBM(Magic_Number);
  Print("                                                                                 ***TAKE PROFIT CLOSE ALL PERFORMED BY PERCENT***");
 }

if (AccountProfit() <= AccountBalance()*(-Stop_Loss))
 {
  CBM(Magic_Number);
  Print("                                                                                   ***STOP LOSS CLOSE ALL PERFORMED BY PERCENT***");
 }
}

if (Close_By_Percent==false)
{
 if (OPBM(Magic_Number) >= Close_By_Profit)
  {
    CBM(Magic_Number);
    Print("                                                                                 ***TAKE PROFIT CLOSE ALL PERFORMED BY PROFIT***");
  }
  if (OPBM(Magic_Number) <= Close_By_Loss)
  {
    CBM(Magic_Number);
    Print("                                                                                   ***STOP LOSS CLOSE ALL PERFORMED BY LOSS***");
  }
}  
}

//////////////////////////////////////////Take Profit or Stop Loss by Percent of Account Balance or by Profit/////////////////////////////////
//                                                     *** If Use_Manuel_Entry = true ***
if (Use_Manual_Entry==true)
{
if (Close_All_Max==true)
 {
  if (OTBM(Magic_Number)==Max_Trades)
   {
    CBM(Magic_Number);
    Print("                                                              ***MAX TRADE HIT CLOSE ALL PERFORMED CYCLE COMPLETE***");
    Alert("TRADE CYCLE COMPLETE *** RESET EA *** RESET MANUEL_LONG AND MANUEL SHORT");
   }
 }

if (Close_By_Percent==true)
{ 
if (AccountProfit() >= AccountBalance()*(Take_Profit))
 {
  CBM(Magic_Number);
  Print("                                                       ***TAKE PROFIT CLOSE ALL PERFORMED BY PERCENT CYCLE COMPLETE***");
  Alert("TRADE CYCLE COMPLETE *** RESET EA *** RESET MANUEL_LONG AND MANUEL SHORT");
 }

if (AccountProfit() <= AccountBalance()*(-Stop_Loss))
 {
  CBM(Magic_Number);
  Print("                                                         ***STOP LOSS CLOSE ALL PERFORMED BY PERCENT CYCLE COMPLETE***");
  Alert("TRADE CYCLE COMPLETE *** RESET EA *** RESET MANUEL_LONG AND MANUEL SHORT");
 }
}

if (Close_By_Percent==false)
{
 if (OPBM(Magic_Number) >= Close_By_Profit)
  {
    CBM(Magic_Number);
    Print("                                                      ***TAKE PROFIT CLOSE ALL PERFORMED BY PROFIT CYCLE COMPLETE***");
    Alert("TRADE CYCLE COMPLETE *** RESET EA *** RESET MANUEL_LONG AND MANUEL SHORT");
  }
  if (OPBM(Magic_Number) <= Close_By_Loss)
  {
    CBM(Magic_Number);
    Print("                                                          ***STOP LOSS CLOSE ALL PERFORMED BY LOSS CYCLE COMPLETE***");
    Alert("TRADE CYCLE COMPLETE *** RESET EA *** RESET MANUEL_LONG AND MANUEL SHORT");
  }
}  
}
///////////////////////////////////////////Call Moving Average for Initial Starting Direction//////////////////////////////////// 
if (Use_Manual_Entry==false)
{
MA_Current=iMA(NULL,MA_Timeframe,MA_Period,0,MODE_EMA,PRICE_CLOSE,0);
MA_Previous=iMA(NULL,MA_Timeframe,MA_Period,0,MODE_EMA,PRICE_CLOSE,1);
}

///////////////////////////////////////////Opening of Additional Orders After Initial Order/////////////////////////////////////////////////////////

if ((OTBM(Magic_Number)>0) && (OTBM(Magic_Number)<Max_Trades))
 {
  if(OrderSelect(Ticket, SELECT_BY_TICKET)==true)
   { 
    Open_Last=OrderOpenPrice();
    //Print("                                                                                         Open_Last =",Open_Last);
     {
      if (Ask >= Open_Last+Next_Trade*Point)
       {
        if(OrderSelect(Ticket, SELECT_BY_TICKET)==true)
         {
          Last_Lotsize=OrderLots();
          //Print("                                                                                    Last_Lotsize =",Last_Lotsize);
           {
            if (Double_Lotsize==false)
             {
              Lot_Size=Last_Lotsize+Lot_Size_Increment;
             }
            if (Double_Lotsize==true)
             {
              Lot_Size=Last_Lotsize*2;
             }
              {
               Ticket=OrderSend(Symbol(),OP_BUY,Lot_Size,Ask,Slippage,NULL,NULL,"TFX_LONG",Magic_Number,0,Green);
              }
           }
         }
       }
     }
   }
 }        

if ((OTBM(Magic_Number)>0) && (OTBM(Magic_Number)<Max_Trades))
 {
  if(OrderSelect(Ticket, SELECT_BY_TICKET)==true)
   { 
    Open_Last=OrderOpenPrice();
    //Print("                                                                                         Open_Last =",Open_Last);
     {
      if (Bid <= Open_Last-Next_Trade*Point)
       {
        if(OrderSelect(Ticket, SELECT_BY_TICKET)==true)
         {
          Last_Lotsize=OrderLots();
          //Print("                                                                                    Last_Lotsize =",Last_Lotsize);
           {
            if (Double_Lotsize==false)
             {
              Lot_Size=Last_Lotsize+Lot_Size_Increment;
             }
            if (Double_Lotsize==true)
             {
              Lot_Size=Last_Lotsize*2;
             }
              {
               Ticket=OrderSend(Symbol(),OP_SELL,Lot_Size,Bid,Slippage,NULL,NULL,"TFX_SHORT",Magic_Number,0,Red);
              }
           }
         }
       }
     }
   }
 }        

  
  
  

//////////////////////////////////////////////////////Open First Order Using MA//////////////////////////////////////////////////////////  

if ((OTBM(Magic_Number)==0) && (Use_Manual_Entry==false))
 {
  if (MA_Current > MA_Previous)
   {
    Lot_Size=Start_Lot_Size;
    Ticket=OrderSend(Symbol(),OP_BUY,Lot_Size,Ask,Slippage,NULL,NULL,"TFX_LONG_START",Magic_Number,0,Green);    
   }
  if (MA_Current < MA_Previous)
   {
    Lot_Size=Start_Lot_Size;
    Ticket=OrderSend(Symbol(),OP_SELL,Lot_Size,Bid,Slippage,NULL,NULL,"TFX_SHORT_START",Magic_Number,0,Red); 
   }
 }
 
//////////////////////////////////////////////////Open First Order Manual/////////////////////////////////////////////////////////

if ((OTBM(Magic_Number)==0) && (Use_Manual_Entry==true) && (Trade_Allowed==true))
{
 if (Ask >= Manual_Long)
  {
   Lot_Size=Start_Lot_Size;
   Ticket=OrderSend(Symbol(),OP_BUY,Lot_Size,Ask,Slippage,NULL,NULL,"TFX_LONG_START",Magic_Number,0,Green);
   Print("                                                                                          ***Start Manuel_Long Hit***");
   Trade_Allowed=false;    
  }
 if (Bid <= Manual_Short)
  {
   Lot_Size=Start_Lot_Size;
   Ticket=OrderSend(Symbol(),OP_SELL,Lot_Size,Bid,Slippage,NULL,NULL,"TFX_SHORT_START",Magic_Number,0,Red);
   Print("                                                                                        ***Start Manuel_Short Hit***");
   Trade_Allowed=false; 
  }
}
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+